'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = _interopDefault(require('react'));
var tapable = require('tapable');

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __awaiter(thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}

function __spread() {
    for (var ar = [], i = 0; i < arguments.length; i++)
        ar = ar.concat(__read(arguments[i]));
    return ar;
}

function debugHooks(obj, includes) {
    return new Proxy(obj, {
        get: function (target, name, receiver) {
            if (name === 'tap' &&
                target[name] &&
                typeof target[name] === 'function') {
                return function (option, func) {
                    var newF = function () {
                        var rest = [];
                        for (var _i = 0; _i < arguments.length; _i++) {
                            rest[_i] = arguments[_i];
                        }
                        var methodName = option;
                        console.group(methodName);
                        console.log.apply(console, __spread(rest));
                        console.groupEnd();
                        return func.apply(void 0, __spread(rest));
                    };
                    return target[name](option, newF);
                };
            }
            else if (target[name] !== null &&
                typeof target[name] === 'object' &&
                includes.includes(name)) {
                return debugHooks(target[name], includes);
            }
            else {
                return Reflect.get(target, name, receiver);
            }
        },
    });
}

function isMenuGroup(item) {
    if (item.subs) {
        return true;
    }
    return false;
}
var HooksProvider = /** @class */ (function () {
    function HooksProvider(plugins, logHooks) {
        var _this = this;
        this.hooks = {
            renderHeaderActions: new tapable.SyncWaterfallHook(['appKey']),
            renderSiderTopSection: new tapable.SyncWaterfallHook(['appKey']),
            renderCustomRoutes: new tapable.SyncWaterfallHook(['appKey', 'RouteComponents', 'mainRender']),
            beforeTablePaginationFinalization: new tapable.SyncWaterfallHook([
                'appKey',
                'pageKey',
                'tableKey',
                'props',
                'dataSource',
                'pagination'
            ]),
            // afterMenusFetched: new SyncHook(['appKey', 'menus']),
            afterPageLoaded: new tapable.SyncHook(['appKey', 'pageKey', 'props']),
            afterPageUnloaded: new tapable.SyncHook(['appKey', 'pageKey', 'props']),
            afterComponentLoaded: new tapable.SyncHook([
                'appKey',
                'pageKey',
                'componentType',
                'componetKey',
                'props',
                'rest'
            ]),
            afterComponentUnloaded: new tapable.SyncHook([
                'appKey',
                'pageKey',
                'componentType',
                'componetKey',
                'props',
            ]),
            beforeSelectDataFetched: new tapable.SyncHook([
                'appKey',
                'pageKey',
                'componentKey',
                'items',
                'selectKey',
            ]),
            afterSelectDataFetched: new tapable.SyncHook([
                'appKey',
                'pageKey',
                'componentKey',
                'items',
                'selectKey',
                'selectData',
            ]),
            beforeTableDataSourceFetched: new tapable.SyncHook([
                'appKey',
                'pageKey',
                'tableKey',
                'columns',
                'pagination'
            ]),
            afterTableDataSourceFetched: new tapable.SyncHook([
                'appKey',
                'pageKey',
                'tableKey',
                'column',
                'dataSource',
                'pagination'
            ]),
            beforeFormItemFinalization: new tapable.SyncHook(['appKey', 'pageKey', 'formKey', 'props', 'item']),
            beforeFormAllItemsFinalization: new tapable.SyncHook(['appKey', 'pageKey', 'formKey', 'props', 'items']),
            beforeTableColumnFinalization: new tapable.SyncHook([
                'appKey',
                'pageKey',
                'tableKey',
                'props',
                'column',
            ]),
            beforeTableAllColumnsFinalization: new tapable.SyncHook([
                'appKey',
                'pageKey',
                'tableKey',
                'props',
                'columns',
            ]),
            beforeButtonClick: new tapable.SyncHook(['appKey', 'pageKey', 'buttonKey']),
            beforeFormSubmit: new tapable.SyncHook(['appKey', 'pageKey', 'formKey', 'values']),
            beforeCheckboxChange: new tapable.SyncHook(['appKey', 'pageKey', 'checkboxKey', 'value']),
            afterTableCellChanged: new tapable.SyncHook(['appKey', 'pageKey', 'tableKey', 'dataSource', 'row']),
            onTabChange: new tapable.SyncHook(['appKey', 'pageKey', 'tabsKey', 'tabKey', 'props']),
            beforeTableRender: new tapable.SyncWaterfallHook([
                'appKey',
                'pageKey',
                'tableKey',
                'props',
                'columns',
                'dataSource',
                'pagination'
            ]),
            beforePanelFetch: new tapable.SyncHook([
                'appKey',
                'pageKey',
                'panelKey',
                'props'
            ]),
            getNewIPaneltems: new tapable.SyncWaterfallHook([
                'appKey',
                'pageKey',
                'panelKey',
                'items',
                'data'
            ])
        };
        if (Array.isArray(plugins)) {
            plugins.forEach(function (plugin) {
                if (logHooks && logHooks.length > 0) {
                    plugin.apply(debugHooks(_this.hooks, logHooks));
                }
                else {
                    plugin.apply(_this.hooks);
                }
            });
        }
    }
    return HooksProvider;
}());
var initialConfig = {
    appKey: 'YOUR_APP_KEY',
    appTitle: 'YOUR_APP_TITLE',
    menus: []
};
var common = { ui: null, config: initialConfig, hooks: new HooksProvider([]).hooks };
var App = React.createContext(common);
function AppProvider(props) {
    return React.createElement(App.Provider, { value: { ui: props.ui, config: props.config, hooks: new HooksProvider(props.plugins, props.debugHooks).hooks } }, props.children);
}

function _Layout(props) {
    var app = React.useContext(App);
    var Comp = app.ui ? app.ui.Layout : null;
    return (React.createElement(Comp, { style: __assign({}, props.style), className: props.className, config: props.config, hide: props.hide, renderRoutes: props.renderRoutes, renderHeaderActions: props.renderHeaderActions, renderSiderTopSection: props.renderSiderTopSection }));
}
var Layout = React.memo(_Layout);

function _Page(props) {
    var app = React.useContext(App);
    React.useEffect(function () {
        app.hooks.afterComponentLoaded.call(app.config.appKey, props.pageKey, 'Page', props.pageKey, props);
        return function () {
            app.hooks.afterComponentUnloaded.call(app.config.appKey, props.pageKey, 'Page', props.pageKey, props);
        };
    }, []);
    var Comp = app.ui ? app.ui.Page : null;
    return (React.createElement(Comp, { style: __assign({}, props.style) }, props.children));
}
var Page = React.memo(_Page);

function createContainer(useHook) {
    var Context = React.createContext(null);
    function Provider(props) {
        var value = useHook(props.initialState);
        return React.createElement(Context.Provider, { value: value }, props.children);
    }
    function useContainer() {
        var value = React.useContext(Context);
        if (value === null) {
            throw new Error("Component must be wrapped with <Container.Provider>");
        }
        return value;
    }
    return { Provider: Provider, useContainer: useContainer };
}

function useIndicator() {
    var _a = __read(React.useState(null), 2), error = _a[0], setError = _a[1];
    var _b = __read(React.useState(null), 2), warning = _b[0], setWarning = _b[1];
    var _c = __read(React.useState(null), 2), success = _c[0], _setSuccess = _c[1];
    var _d = __read(React.useState(null), 2), info = _d[0], _setInfo = _d[1];
    var _e = __read(React.useState(0), 2), requestQuantity = _e[0], _setRequestQuantity = _e[1];
    var clearSuccess = function () { return _setSuccess(null); };
    var clearInfo = function () { return _setInfo(null); };
    var clearWarning = function () { return setWarning(null); };
    var clearError = function () { return setError(null); };
    var clearRequest = function () { return _setRequestQuantity(0); };
    var setSuccess = function (message) {
        _setSuccess(message);
        setTimeout(function () {
            clearSuccess();
        }, 3000);
    };
    var setInfo = function (message) {
        _setInfo(message);
        setTimeout(function () {
            clearInfo();
        }, 3000);
    };
    var startRequest = React.useCallback(function () {
        _setRequestQuantity(function (prevQuantity) { return prevQuantity + 1; });
    }, []);
    var endRequest = React.useCallback(function () {
        _setRequestQuantity(function (prevQuantity) { return prevQuantity - 1; });
    }, []);
    return {
        error: error,
        warning: warning,
        success: success,
        info: info,
        requestQuantity: requestQuantity,
        setError: setError,
        setWarning: setWarning,
        setSuccess: setSuccess,
        setInfo: setInfo,
        clearError: clearError,
        clearInfo: clearInfo,
        clearSuccess: clearSuccess,
        clearWarning: clearWarning,
        startRequest: startRequest,
        endRequest: endRequest,
        clearRequest: clearRequest
    };
}

function useFilter() {
    var _a = __read(React.useState({}), 2), _filter = _a[0], _setFilter = _a[1];
    var getFilter = function (pageKey, tableKey) {
        var f = _filter[pageKey + "_" + tableKey];
        return f;
    };
    var setFilter = function (pageKey, tableKey, values) {
        var _a;
        values.resetCurrentPage = true;
        _setFilter(__assign({}, _filter, (_a = {}, _a[pageKey + "_" + tableKey] = values, _a)));
    };
    return { getFilter: getFilter, setFilter: setFilter };
}

function useModal() {
    var _a = __read(React.useState({}), 2), _modalShow = _a[0], _setModalShow = _a[1];
    var isShowModal = function (pageKey, modalKey) {
        var f = _modalShow[pageKey + "_" + modalKey];
        return f;
    };
    var hideModal = function (pageKey, modalKey) {
        var _a;
        _setModalShow(__assign({}, _modalShow, (_a = {}, _a[pageKey + "_" + modalKey] = false, _a)));
    };
    var showModal = function (pageKey, modalKey) {
        var _a;
        _setModalShow(__assign({}, _modalShow, (_a = {}, _a[pageKey + "_" + modalKey] = true, _a)));
    };
    return { isShowModal: isShowModal, hideModal: hideModal, showModal: showModal };
}

function useParams() {
    var _a = __read(React.useState({}), 2), _params = _a[0], _setParams = _a[1];
    //使用 useRef
    var countRef = React.useRef();
    countRef.current = _params;
    var getParams = function (pageKey, sectionKey) {
        var params = countRef.current || {};
        var f = params[pageKey + "_" + sectionKey];
        return f;
    };
    var setParams = function (pageKey, sectionKey, value) {
        var _a;
        var params = countRef.current || {};
        _setParams(__assign({}, params, (_a = {}, _a[pageKey + "_" + sectionKey] = value, _a)));
    };
    return { getParams: getParams, setParams: setParams };
}

function usePage() {
    var indicator = useIndicator();
    var filter = useFilter();
    var modal = useModal();
    var params = useParams();
    return __assign({}, indicator, filter, modal, params);
}

var Pages = createContainer(usePage);

var href = window.location.href;
function fetch2(url, options, loginUrl) {
    if (loginUrl === void 0) { loginUrl = ''; }
    var realUrl = url;
    var opt = options || {};
    opt.credentials = opt.credentials || 'include';
    return fetch(realUrl, opt)
        .then(function (response) { return response.json(); })
        .then(function (json) {
        if (json.code === 40003 ||
            json.code === 50003 ||
            json.code === 201 ||
            json.code === 401 ||
            json.code === 40012) {
            var return_login = loginUrl + '?returnUrl=' + encodeURIComponent(href);
            window.location.replace(return_login);
            throw new Error('Please Login First!');
        }
        else {
            return json;
        }
    });
}
function GET(url, loginUrl) {
    return __awaiter(this, void 0, void 0, function () {
        var error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, REQ('get', url, loginUrl)];
                case 1: return [2 /*return*/, _a.sent()];
                case 2:
                    error_1 = _a.sent();
                    throw error_1;
                case 3: return [2 /*return*/];
            }
        });
    });
}
function POST(url, loginUrl, body) {
    return __awaiter(this, void 0, void 0, function () {
        var error_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, REQ('post', url, loginUrl, body)];
                case 1: return [2 /*return*/, _a.sent()];
                case 2:
                    error_2 = _a.sent();
                    throw error_2;
                case 3: return [2 /*return*/];
            }
        });
    });
}
function REQ(method, url, loginUrl, body) {
    return __awaiter(this, void 0, void 0, function () {
        var data, error_3;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, fetch2(url, method === 'post' ? {
                            method: 'POST',
                            headers: {
                                'Accept': 'application/json',
                                'Content-Type': 'application/json',
                            },
                            body: JSON.stringify(body),
                        } : null, loginUrl)];
                case 1:
                    data = _a.sent();
                    return [2 /*return*/, data];
                case 2:
                    error_3 = _a.sent();
                    throw error_3;
                case 3: return [2 /*return*/];
            }
        });
    });
}
var addParam = function (url, param, value) {
    param = encodeURIComponent(param);
    var a = document.createElement('a');
    param += (value ? "=" + encodeURIComponent(value) : "");
    a.href = url;
    a.search += (a.search ? "&" : "") + param;
    return a.href;
};

function useGET() {
    var _this = this;
    var app = React.useContext(App);
    var _a = Pages.useContainer(), setError = _a.setError, startRequest = _a.startRequest, endRequest = _a.endRequest;
    var send = React.useCallback(function (url, filter) { return __awaiter(_this, void 0, void 0, function () {
        var u, paramsStr_1, data, error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    startRequest();
                    u = url;
                    if (filter && Object.keys(filter).length > 0) {
                        paramsStr_1 = '?';
                        Object.keys(filter).forEach(function (k) {
                            paramsStr_1 += k + "=" + filter[k] + "&";
                        });
                        u = "" + url + paramsStr_1.slice(0, -1);
                    }
                    return [4 /*yield*/, GET(u, app.config.loginUrl)];
                case 1:
                    data = _a.sent();
                    endRequest();
                    //TODO: DOC
                    if (data.code === 0 && data.data) {
                        return [2 /*return*/, data];
                    }
                    else {
                        setError(data);
                    }
                    return [3 /*break*/, 3];
                case 2:
                    error_1 = _a.sent();
                    setError(error_1);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/, null];
            }
        });
    }); }, []);
    return send;
}

function usePOST() {
    var _this = this;
    var app = React.useContext(App);
    var _a = Pages.useContainer(), setError = _a.setError, startRequest = _a.startRequest, endRequest = _a.endRequest;
    var send = React.useCallback(function (url, body) { return __awaiter(_this, void 0, void 0, function () {
        var data, error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    startRequest();
                    return [4 /*yield*/, POST(url, app.config.loginUrl, body)];
                case 1:
                    data = _a.sent();
                    endRequest();
                    //TODO: DOC
                    if (data.code === 0 && data.data) {
                        return [2 /*return*/, data];
                    }
                    else {
                        setError(data);
                    }
                    return [3 /*break*/, 3];
                case 2:
                    error_1 = _a.sent();
                    setError(error_1);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/, null];
            }
        });
    }); }, []);
    return send;
}

function getValueByKeypath(modal, keypath) {
    var keys = keypath.split('.').map(function (s) { return s.trim(); }).filter(function (s) { return s; });
    var value = modal;
    for (var index = 0; index < keys.length; index++) {
        var key = keys[index];
        value = value[key];
    }
    return value;
}

function useTable(pageKey, tableKey, columns, meta, reload) {
    var app = React.useContext(App);
    var get = useGET();
    var post = usePOST();
    var filter = Pages.useContainer().getFilter(pageKey, tableKey);
    var getParams = Pages.useContainer().getParams;
    var dataType = pageKey.toUpperCase() + "_" + tableKey.toUpperCase() + "_TABLE_DATA_FETCHED";
    var pageType = pageKey.toUpperCase() + "_" + tableKey.toUpperCase() + "_TABLE_SET_CURRENT_PAGE";
    var sizeType = pageKey.toUpperCase() + "_" + tableKey.toUpperCase() + "_TABLE_SET_PAGE_SIZE";
    var _a = __read(React.useReducer(function (state, action) {
        switch (action.type) {
            case dataType:
                return __assign({}, state, { dataSource: action.dataSource, total: action.total });
            case pageType:
                return __assign({}, state, { currentPage: action.page });
            case sizeType:
                return __assign({}, state, { pageSize: action.size });
            default:
                throw new Error();
        }
    }, { dataSource: [], currentPage: 1, total: 0, pageSize: meta.pageSize || 20 }), 2), state = _a[0], dispatch = _a[1];
    var currentPage = state.currentPage, pageSize = state.pageSize;
    var setCurrentPage = React.useCallback(function (page) {
        dispatch({ type: pageType, page: page });
    }, []);
    var setPageSize = React.useCallback(function (size) {
        dispatch({ type: sizeType, size: size });
    }, []);
    if (filter && filter.resetCurrentPage) {
        dispatch({ type: pageType, page: 1 });
        delete filter.resetCurrentPage;
    }
    React.useEffect(function () {
        var mounted = true;
        function fetchTableData(p, t, u) {
            return __awaiter(this, void 0, void 0, function () {
                var dataSource, totalCount, currentPageKey, pageSizeKey, listKey, totalKey, req, reqParamKey, values_1, reqParam_1, result, list, result, list, total;
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            app.hooks.beforeTableDataSourceFetched.call(app.config.appKey, p, t, columns, { total: 0, currentPage: currentPage, pageSize: pageSize });
                            dataSource = [];
                            totalCount = 0;
                            if (!meta.data) return [3 /*break*/, 1];
                            dataSource = meta.data.filter(function (d) {
                                if (!filter || !filter.type)
                                    return true;
                                else
                                    return d.typeId === filter.type;
                            });
                            totalCount = dataSource.length;
                            return [3 /*break*/, 5];
                        case 1:
                            currentPageKey = 'currentPage';
                            pageSizeKey = 'pageSize';
                            listKey = 'list';
                            totalKey = 'total';
                            if (meta.alias) {
                                if (meta.alias.currentPage)
                                    currentPageKey = meta.alias.currentPage;
                                if (meta.alias.pageSize)
                                    pageSizeKey = meta.alias.pageSize;
                                if (meta.alias.list)
                                    listKey = meta.alias.list;
                                if (meta.alias.total)
                                    totalKey = meta.alias.total;
                            }
                            req = get;
                            reqParamKey = 'get';
                            if (meta.method && meta.method.toLowerCase() === 'post') {
                                req = post;
                                reqParamKey = 'post';
                            }
                            values_1 = {};
                            if (meta.params && meta.params[reqParamKey]) {
                                reqParam_1 = meta.params[reqParamKey];
                                Object.keys(reqParam_1).forEach(function (k) {
                                    var value = reqParam_1[k];
                                    var cKey = meta.modal || meta.componentKey || tableKey || null;
                                    if (cKey && value && (value + '').startsWith('$.')) {
                                        var params = getParams(pageKey, cKey);
                                        if (params) {
                                            values_1[k] = params[value.split('.')[1]];
                                        }
                                    }
                                    else {
                                        values_1[k] = value;
                                    }
                                });
                            }
                            if (!meta.disablePagination) return [3 /*break*/, 3];
                            return [4 /*yield*/, req(u, __assign({}, filter, values_1))];
                        case 2:
                            result = _b.sent();
                            if (result && result.data) {
                                list = getValueByKeypath(result.data, listKey);
                                if (list) {
                                    dataSource = list;
                                }
                                else if (Array.isArray(result.data)) {
                                    dataSource = result.data;
                                }
                                totalCount = 0;
                            }
                            return [3 /*break*/, 5];
                        case 3: return [4 /*yield*/, req(u, __assign({}, filter, values_1, (_a = {}, _a[currentPageKey] = currentPage, _a[pageSizeKey] = pageSize, _a)))];
                        case 4:
                            result = _b.sent();
                            if (result && result.data) {
                                list = getValueByKeypath(result.data, listKey);
                                total = getValueByKeypath(result.data, totalKey);
                                if (list && total) {
                                    dataSource = list;
                                    totalCount = total;
                                }
                            }
                            _b.label = 5;
                        case 5:
                            app.hooks.afterTableDataSourceFetched.call(app.config.appKey, p, t, columns, dataSource, { total: totalCount, currentPage: currentPage, pageSize: pageSize });
                            //TODO: doc: better to config "id: true", or use index key
                            if (mounted)
                                dispatch({ type: dataType, dataSource: dataSource.map(function (d, i) { return (__assign({}, d, { key: i })); }), total: totalCount });
                            return [2 /*return*/];
                    }
                });
            });
        }
        if (meta.url) {
            fetchTableData(pageKey, tableKey, meta.url);
        }
        return function () { mounted = false; };
    }, [pageKey, tableKey, meta.url, filter, currentPage, pageSize, reload]);
    return __assign({}, state, { setCurrentPage: setCurrentPage, setPageSize: setPageSize });
}

function useSelect(pageKey, componentKey, items, reload) {
    var app = React.useContext(App);
    var get = useGET();
    var type = pageKey.toUpperCase() + "_" + componentKey.toUpperCase() + "_SELECT_DATA_FETCHED";
    var _a = __read(React.useReducer(function (state, action) {
        switch (action.type) {
            case type:
                return __assign({}, state, { data: action.data });
            default:
                throw new Error();
        }
    }, { data: items }), 2), state = _a[0], dispatch = _a[1];
    React.useEffect(function () {
        var mounted = true;
        function fetchSelectData(itemKey, itemUrl, itemAlias) {
            return __awaiter(this, void 0, void 0, function () {
                var result, data;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            app.hooks.beforeSelectDataFetched.call(app.config.appKey, pageKey, componentKey, items, itemKey);
                            return [4 /*yield*/, get(itemUrl)];
                        case 1:
                            result = (_a.sent()) || [];
                            app.hooks.afterSelectDataFetched.call(app.config.appKey, pageKey, componentKey, items, itemKey, result.data);
                            data = [];
                            if (Array.isArray(result.data)) {
                                data = result.data;
                            }
                            else if ((typeof result.data === 'object')) {
                                if (itemAlias) {
                                    data = getValueByKeypath(result.data, itemAlias.list || 'list');
                                }
                                else {
                                    data = result.data.list || [];
                                }
                            }
                            if (itemAlias) {
                                data = data.map(function (d) { return ({
                                    label: getValueByKeypath(d, itemAlias.label || 'label'),
                                    value: getValueByKeypath(d, itemAlias.value || 'value')
                                }); });
                            }
                            return [2 /*return*/, data];
                    }
                });
            });
        }
        function handleSelect(itms) {
            return __awaiter(this, void 0, void 0, function () {
                var selectItems;
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            selectItems = itms.filter(function (i) { return i.type === 'select'; });
                            if (selectItems.length <= 0)
                                return [2 /*return*/]; // 阻止无 select 的 items 造成一次重复渲染
                            return [4 /*yield*/, Promise.all(selectItems.map(function (i) { return __awaiter(_this, void 0, void 0, function () {
                                    var originalUrl_1, refItem, refReq_1, _a;
                                    var _this = this;
                                    return __generator(this, function (_b) {
                                        switch (_b.label) {
                                            case 0:
                                                if (i.meta) {
                                                    i.meta.showSearch = true;
                                                }
                                                if (!(i.meta && i.meta.data)) return [3 /*break*/, 1];
                                                return [2 /*return*/, i];
                                            case 1:
                                                if (!(i.meta && i.meta.ref)) return [3 /*break*/, 2];
                                                if (i.meta.refData) {
                                                    i.meta.data = function (refValue) { return i.meta.refData[refValue]; };
                                                    return [2 /*return*/, i];
                                                }
                                                else if (i.meta.url) {
                                                    originalUrl_1 = i.meta.url;
                                                    refItem = itms.find(function (it) { return it.key === i.meta.ref; });
                                                    refReq_1 = function (value) { return __awaiter(_this, void 0, void 0, function () {
                                                        var url, selectData;
                                                        return __generator(this, function (_a) {
                                                            switch (_a.label) {
                                                                case 0:
                                                                    url = originalUrl_1.replace('$refValue', value);
                                                                    return [4 /*yield*/, fetchSelectData(i.key, url, i.meta.alias)];
                                                                case 1:
                                                                    selectData = _a.sent();
                                                                    i.meta.data = selectData;
                                                                    if (mounted)
                                                                        dispatch({ type: type, data: itms });
                                                                    return [2 /*return*/];
                                                            }
                                                        });
                                                    }); };
                                                    if (refItem.value) {
                                                        refReq_1(refItem.value);
                                                    }
                                                    refItem.onChange = function (value) { return __awaiter(_this, void 0, void 0, function () {
                                                        return __generator(this, function (_a) {
                                                            refReq_1(value);
                                                            return [2 /*return*/];
                                                        });
                                                    }); };
                                                    i.meta.data = [];
                                                    return [2 /*return*/, i];
                                                }
                                                return [3 /*break*/, 4];
                                            case 2:
                                                if (!(i.meta && i.meta.url)) return [3 /*break*/, 4];
                                                _a = i.meta;
                                                return [4 /*yield*/, fetchSelectData(i.key, i.meta.url, i.meta.alias)];
                                            case 3:
                                                _a.data = _b.sent();
                                                return [2 /*return*/, i];
                                            case 4: return [2 /*return*/];
                                        }
                                    });
                                }); }))];
                        case 1:
                            _a.sent();
                            if (mounted)
                                dispatch({ type: type, data: itms });
                            return [2 /*return*/];
                    }
                });
            });
        }
        handleSelect(items);
        return function () { mounted = false; };
    }, [pageKey, componentKey, items, reload]);
    return state.data;
}

function _Table(props) {
    var app = React.useContext(App);
    var dataSourceRef = React.useRef([]);
    var _a = __read(React.useReducer(function (x) { return x + 1; }, 0), 2), reload = _a[0], _forceReload = _a[1];
    function forceReload() {
        _forceReload(1);
    }
    var _b = __read(React.useReducer(function (x) { return x + 1; }, 0), 2), reloadWithoutFetch = _b[0], _forceReloadWithoutFetch = _b[1];
    function forceReloadWithoutFetch() {
        _forceReloadWithoutFetch(1);
    }
    React.useEffect(function () {
        if (props.meta.data && typeof props.meta.data === 'string') {
            if (props.meta.modal && props.meta.data.startsWith('$.')) {
                var params = getParams(props.pageKey, props.meta.modal);
                if (params) {
                    var valueKey = props.meta.data.split('.')[1];
                    var data = params[valueKey];
                    if (data && Array.isArray(data)) {
                        dataSourceRef.current = data.map(function (d, index) {
                            var _a;
                            return (__assign({}, d, (_a = {}, _a[rowKey] = (d[rowKey] || index), _a)));
                        });
                    }
                    else {
                        dataSourceRef.current = [];
                    }
                }
                else {
                    dataSourceRef.current = [];
                }
            }
            else {
                dataSourceRef.current = [];
            }
        }
        else {
            try {
                dataSourceRef.current = JSON.parse(JSON.stringify(props.meta.data || []));
            }
            catch (error) {
                dataSourceRef.current = [];
            }
        }
        setTimeout(function () {
            handleFormData(dataSourceRef.current);
        }, 0);
        forceReloadWithoutFetch();
        app.hooks.afterComponentLoaded.call(app.config.appKey, props.pageKey, 'Table', props.tableKey, props, { forceReload: forceReload, forceReloadWithoutFetch: forceReloadWithoutFetch });
        return function () {
            dataSourceRef.current = [];
            app.hooks.afterComponentUnloaded.call(app.config.appKey, props.pageKey, 'Table', props.tableKey, props);
        };
    }, []);
    var _c = Pages.useContainer(), showModal = _c.showModal, setParams = _c.setParams, getParams = _c.getParams;
    var keyItem = props.columns.find(function (c) { return !!c.id; });
    var rowKey = keyItem ? keyItem.key : 'key';
    var get = useGET();
    var post = usePOST();
    function extraRequest(meta, record) {
        return __awaiter(this, void 0, void 0, function () {
            var result, params_1, url, reqString_1, get_1, values_1, post_1, params, aParams_1, keys;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        result = null;
                        if (!meta.url) return [3 /*break*/, 4];
                        params_1 = meta.params;
                        if (!(!meta.method || meta.method.toUpperCase() === 'GET')) return [3 /*break*/, 2];
                        url = meta.url;
                        reqString_1 = '?';
                        if (params_1 && params_1.get) {
                            get_1 = params_1.get;
                            Object.keys(get_1).forEach(function (k) {
                                var value = get_1[k];
                                if (value.startsWith('$.')) {
                                    reqString_1 += k + "=" + record[value.split('.')[1]] + "&";
                                }
                                else {
                                    reqString_1 += k + "=" + value + "&";
                                }
                            });
                            url += reqString_1.substring(0, reqString_1.length - 1);
                        }
                        return [4 /*yield*/, get(url)];
                    case 1:
                        result = (_a.sent()) || [];
                        return [3 /*break*/, 4];
                    case 2:
                        if (!(meta.method.toUpperCase() === 'POST')) return [3 /*break*/, 4];
                        values_1 = {};
                        if (params_1 && params_1.post) {
                            post_1 = params_1.post;
                            Object.keys(post_1).forEach(function (k) {
                                var value = post_1[k];
                                if (value && (value + '').startsWith('$.')) {
                                    values_1[k] = record[value.split('.')[1]];
                                }
                                else {
                                    values_1[k] = value;
                                }
                            });
                        }
                        return [4 /*yield*/, post(meta.url, values_1)];
                    case 3:
                        result = _a.sent();
                        if (result)
                            forceReload();
                        _a.label = 4;
                    case 4:
                        params = {};
                        if (meta.params && Object.keys(meta.params).length > 0) {
                            aParams_1 = meta.params;
                            params = {};
                            keys = Object.keys(meta.params);
                            keys.forEach(function (k) {
                                if (k === 'post' || k === 'get')
                                    return;
                                var value = aParams_1[k];
                                if (value && (value + '').startsWith('$.')) {
                                    params[k] = record[value.split('.')[1]];
                                }
                                else if (value && (value + '').startsWith('$#') && result && result.data) {
                                    params[k] = getValueByKeypath(result.data, value.split('#')[1]);
                                }
                                else {
                                    params[k] = value;
                                }
                            });
                        }
                        if (meta.modal && meta.modal.length > 0) {
                            setParams(props.pageKey, meta.modal, __assign({}, params, { forceReload: forceReload }));
                            showModal(props.pageKey, meta.modal);
                        }
                        return [2 /*return*/];
                }
            });
        });
    }
    var columns = useSelect(props.pageKey, props.tableKey, props.columns, 1);
    var emptyAction = undefined;
    columns = columns.map(function (c) {
        var actions = c.actions;
        if (c.actions && c.actions.length > 0) {
            var blankValue_1 = {};
            var insertAction_1 = function (index) {
                var _a;
                dataSourceRef.current = dataSourceRef.current || [];
                dataSourceRef.current.splice(index + 1, 0, __assign({}, blankValue_1, (_a = {}, _a[rowKey] = new Date().getTime(), _a)));
                forceReload();
            };
            actions = c.actions.map(function (a) {
                if (a.meta.rowAction && a.meta.rowAction === 'insert') {
                    emptyAction = {};
                    emptyAction.title = a.meta.label;
                    emptyAction.callback = function () { insertAction_1(0); };
                }
                var actionShow = true;
                if ((typeof a.meta.show) === 'boolean') {
                    actionShow = !!a.meta.show;
                }
                else if (a.meta.show && (typeof a.meta.show) === 'string') {
                    var showString_1 = a.meta.show;
                    if (showString_1.startsWith('$.')) {
                        actionShow = function (text, record, index) {
                            var valueKey = showString_1.split('.')[1];
                            return !!record[valueKey];
                        };
                    }
                }
                return {
                    key: a.key,
                    label: a.meta.label,
                    confirm: a.meta.confirm,
                    confirmLabel: a.meta.confirmLabel,
                    show: actionShow,
                    callback: function (text, record, index) {
                        if (a.meta.rowAction) {
                            var keys = Object.keys(record);
                            keys.forEach(function (k) {
                                blankValue_1[k] = undefined;
                            });
                            if (a.meta.rowAction === 'insert') {
                                insertAction_1(index);
                            }
                            else if (a.meta.rowAction === 'delete' && dataSourceRef.current) {
                                dataSourceRef.current = dataSourceRef.current.slice(0).filter(function (d) { return d[rowKey] !== record[rowKey]; });
                                handleFormData(dataSourceRef.current);
                                forceReload();
                            }
                        }
                        else if (a.meta.link) {
                            var link = a.meta.link;
                            if (link.startsWith('/')) {
                                props.history.push(link.substring(1));
                            }
                            else {
                                props.history.push(props.match.url + "/" + link);
                            }
                        }
                        else {
                            extraRequest(a.meta, record);
                        }
                    },
                    modal: a.meta ? a.meta.modal : null
                };
            });
        }
        app.hooks.beforeTableColumnFinalization.call(app.config.appKey, props.pageKey, props.tableKey, props, c);
        return __assign({}, c, { actions: actions, dataIndex: c.key, title: c.label });
    });
    app.hooks.beforeTableAllColumnsFinalization.call(app.config.appKey, props.pageKey, props.tableKey, props, columns);
    function handleFormData(dataSource) {
        if (props.meta.form) {
            var ps = { list: dataSource };
            if (props.meta.params && props.meta.params.form) {
                var _a = props.meta.params.form, key = _a.key, fields_1 = _a.fields;
                ps = {};
                if (fields_1 && fields_1.length > 0) {
                    ps[key] = dataSource.map(function (d) {
                        var data = {};
                        Object.keys(d).forEach(function (k) {
                            if (fields_1.includes(k)) {
                                data[k] = d[k];
                            }
                        });
                        return data;
                    });
                }
                else {
                    ps[key] = dataSource;
                }
            }
            var lastParams = getParams(props.pageKey, props.meta.form);
            var newParams = lastParams ? __assign({}, lastParams, ps) : ps;
            setParams(props.pageKey, props.meta.form, newParams);
        }
    }
    var Comp = app.ui ? app.ui.Table : null;
    function renderTable(dataSource, pagination) {
        var _a;
        var values = getParams(props.pageKey, props.tableKey);
        if (values && Object.keys(values).length > 0) {
            var found_1 = dataSource.find(function (d) { return d[rowKey] === values[rowKey]; });
            if (found_1) {
                Object.keys(found_1).forEach(function (k) {
                    found_1[k] = null;
                });
                Object.keys(values).forEach(function (k) {
                    found_1[k] = values[k];
                });
            }
            else {
                dataSource.push(__assign((_a = {}, _a[rowKey] = new Date().getTime(), _a), values));
            }
            setParams(props.pageKey, props.tableKey, {});
            setTimeout(function () {
                handleFormData(dataSource);
            }, 0);
        }
        var result = app.hooks.beforeTableRender.call(app.config.appKey, props.pageKey, props.tableKey, props, columns, dataSource, pagination);
        if (result && (typeof result !== 'string')) {
            return result;
        }
        return (React.createElement(Comp, { style: __assign({}, props.style), emptyAction: emptyAction, title: props.meta.label, appKey: app.config.appKey, pageKey: props.pageKey, tableKey: props.tableKey, className: props.className, rowKey: rowKey, columns: columns, dataSource: dataSource, onPageChange: pagination ? function (page, pSize) {
                if (page !== pagination.currentPage)
                    pagination.setCurrentPage(page);
                if (pSize !== pagination.pageSize)
                    pagination.setPageSize(pSize);
            } : undefined, onCellChanged: function (dataSource, row, key) {
                app.hooks.afterTableCellChanged.call(app.config.appKey, props.pageKey, props.tableKey, dataSource, row);
                // const column = props.columns.find((c: any) => c.key === key)
                // if (column && column.meta) {
                //     extraRequest(column.meta, row)
                // }
                handleFormData(dataSource);
            }, pagination: pagination ? __assign({ current: pagination.currentPage, total: pagination.total, pageSize: pagination.pageSize, position: 'both' }, pagination.extraPagination) : false }));
    }
    var _d = useTable(props.pageKey, props.tableKey, columns, props.meta, reload), dataSource = _d.dataSource, currentPage = _d.currentPage, total = _d.total, pageSize = _d.pageSize, setCurrentPage = _d.setCurrentPage, setPageSize = _d.setPageSize;
    if (props.meta && props.meta.url) {
        var extraPagination = {};
        var pagination = { currentPage: currentPage, total: total, pageSize: pageSize, setCurrentPage: setCurrentPage, setPageSize: setPageSize, extraPagination: extraPagination };
        app.hooks.beforeTablePaginationFinalization.call(app.config.appKey, props.pageKey, props.tableKey, props, dataSource, pagination);
        return renderTable(dataSource, props.meta.disablePagination ? false : pagination);
    }
    else {
        return renderTable(dataSourceRef.current || [], false);
    }
}
var Table = React.memo(_Table);

function useSubmit(url, method, pageKey, modalKey) {
    var _this = this;
    var get = useGET();
    var post = usePOST();
    var _a = Pages.useContainer(), setSuccess = _a.setSuccess, hideModal = _a.hideModal, getParams = _a.getParams;
    var send = React.useCallback(function (values) { return __awaiter(_this, void 0, void 0, function () {
        var result, params;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    result = null;
                    if (!(method && method.toLowerCase() === 'post')) return [3 /*break*/, 2];
                    return [4 /*yield*/, post(url, values)];
                case 1:
                    result = _a.sent();
                    if (modalKey) {
                        params = getParams(pageKey, modalKey);
                        if (params && params.forceReload) {
                            params.forceReload();
                        }
                        else
                            window.location.reload(true);
                    }
                    if (result && result.message) {
                        setSuccess({ message: result.message });
                    }
                    return [3 /*break*/, 4];
                case 2: return [4 /*yield*/, get(url, values)];
                case 3:
                    result = _a.sent();
                    _a.label = 4;
                case 4:
                    if (result && modalKey) {
                        hideModal(pageKey, modalKey);
                    }
                    return [2 /*return*/];
            }
        });
    }); }, []);
    return send;
}

function _Button(props) {
    var _this = this;
    var app = React.useContext(App);
    var get = useGET();
    var post = usePOST();
    React.useEffect(function () {
        app.hooks.afterComponentLoaded.call(app.config.appKey, props.pageKey, 'Button', props.buttonKey, props);
        return function () {
            app.hooks.afterComponentUnloaded.call(app.config.appKey, props.pageKey, 'Button', props.buttonKey, props);
        };
    }, []);
    var showModal = Pages.useContainer().showModal;
    var Comp = app.ui ? app.ui.Button : null;
    if (props.meta.url && !props.meta.href && !props.meta.method) { // 兼容旧 API
        props.meta.href = props.meta.url;
    }
    return (React.createElement(Comp, __assign({}, props.meta, { style: __assign({}, props.style), onClick: function () { return __awaiter(_this, void 0, void 0, function () {
            var link, result, prm;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        app.hooks.beforeButtonClick.call(app.config.appKey, props.pageKey, props.buttonKey);
                        if (!(props.meta.modal && props.meta.modal.length > 0)) return [3 /*break*/, 1];
                        showModal(props.pageKey, props.meta.modal);
                        return [3 /*break*/, 6];
                    case 1:
                        if (!props.meta.link) return [3 /*break*/, 2];
                        link = props.meta.link;
                        if (link === '<') {
                            props.history.goBack();
                        }
                        else if (link.startsWith('/')) {
                            props.history.push(link.substring(1));
                        }
                        else {
                            props.history.push(props.match.url + "/" + link);
                        }
                        return [3 /*break*/, 6];
                    case 2:
                        if (!(props.meta.url && props.meta.method)) return [3 /*break*/, 6];
                        result = null;
                        prm = props.meta.params;
                        if (!(!props.meta.method || props.meta.method.toUpperCase() === 'GET')) return [3 /*break*/, 4];
                        return [4 /*yield*/, get(props.meta.url, (prm && prm.get) ? prm.get : {})];
                    case 3:
                        result = (_a.sent()) || [];
                        if (result)
                            props.forceUpdate();
                        return [3 /*break*/, 6];
                    case 4:
                        if (!(props.meta.method.toUpperCase() === 'POST')) return [3 /*break*/, 6];
                        return [4 /*yield*/, post(props.meta.url, (prm && prm.post) ? prm.post : {})];
                    case 5:
                        result = _a.sent();
                        if (result)
                            props.forceUpdate();
                        _a.label = 6;
                    case 6: return [2 /*return*/];
                }
            });
        }); } })));
}
var Button = React.memo(_Button);

function _Modal(props) {
    var app = React.useContext(App);
    React.useEffect(function () {
        app.hooks.afterComponentLoaded.call(app.config.appKey, props.pageKey, 'Modal', props.modalKey, props);
        return function () {
            app.hooks.afterComponentUnloaded.call(app.config.appKey, props.pageKey, 'Modal', props.modalKey, props);
        };
    }, []);
    var _a = Pages.useContainer(), hideModal = _a.hideModal, isShowModal = _a.isShowModal, getParams = _a.getParams;
    var Comp = app.ui ? app.ui.Modal : null;
    var newTitle = props.title;
    if (props.title) {
        if (props.title.startsWith('$.')) {
            var params = getParams(props.pageKey, props.modalKey);
            if (params) {
                var valueKey = props.title.split('.')[1];
                newTitle = params[valueKey];
            }
        }
        else {
            var reg = /{\$\.([^{}]*)}/g;
            if (reg.test(props.title)) {
                newTitle = props.title.replace(reg, function (match, p1) {
                    var valueKey = p1.trim();
                    var params = getParams(props.pageKey, props.modalKey);
                    if (params) {
                        return params[valueKey];
                    }
                    return valueKey;
                });
            }
        }
    }
    return (React.createElement(Comp, { style: { display: 'none' }, visible: isShowModal(props.pageKey, props.modalKey), title: newTitle, width: props.width, onCancel: function () {
            hideModal(props.pageKey, props.modalKey);
        } },
        React.createElement(Stack, { pageKey: props.pageKey, items: props.contents, direction: "vertical", stackKey: props.pageKey + "_" + props.modalKey + "_main_stack", history: props.history, match: props.match })));
}
var Modal = _Modal;

function _Checkbox(props) {
    var app = React.useContext(App);
    React.useEffect(function () {
        app.hooks.afterComponentLoaded.call(app.config.appKey, props.pageKey, 'Checkbox', props.checkboxKey, props);
        return function () {
            app.hooks.afterComponentUnloaded.call(app.config.appKey, props.pageKey, 'Checkbox', props.checkboxKey, props);
        };
    }, []);
    var setParams = Pages.useContainer().setParams;
    var Comp = app.ui ? app.ui.Checkbox : null;
    return (React.createElement(Comp, { style: __assign({}, props.style), title: props.meta.label, onChange: function (value) {
            app.hooks.beforeCheckboxChange.call(app.config.appKey, props.pageKey, props.checkboxKey, value);
            if (props.meta.params && props.meta.params.set) {
                setParams(props.pageKey, props.checkboxKey, { checked: value.target.checked });
            }
        } }));
}
var Checkbox = React.memo(_Checkbox);

function _Tabs(props) {
    var app = React.useContext(App);
    React.useEffect(function () {
        app.hooks.afterComponentLoaded.call(app.config.appKey, props.pageKey, 'Tabs', props.tabsKey, props);
        return function () {
            app.hooks.afterComponentUnloaded.call(app.config.appKey, props.pageKey, 'Tabs', props.tabsKey, props);
        };
    }, []);
    var Tabs = app.ui ? app.ui.Tabs : null;
    var TabPanel = Tabs.Panel;
    var defaultTab = props.items.find(function (i) { return i.default; });
    if (!defaultTab && props.items.length > 0) {
        defaultTab = props.items[0];
    }
    return (React.createElement(Tabs, { defaultActiveKey: defaultTab ? defaultTab.key : undefined, onChange: function (key) {
            app.hooks.onTabChange.call(app.config.appKey, props.pageKey, props.tabsKey, key, props);
        } }, props.items.map(function (i) {
        return (React.createElement(TabPanel, { tab: i.label, panelKey: i.key, key: i.key },
            React.createElement(Stack, { pageKey: props.pageKey, items: i.items || [], direction: "vertical", stackKey: props.pageKey + "_" + props.tabsKey + "_" + i.key + "_main_stack", history: props.history, match: props.match })));
    })));
}
var Tabs = React.memo(_Tabs);

function _Panel(props) {
    var _this = this;
    var app = React.useContext(App);
    var getFilter = Pages.useContainer().getFilter;
    var filterRef = React.useRef({});
    var panelItems = React.useRef(JSON.parse(JSON.stringify(props.items)));
    React.useEffect(function () {
        app.hooks.afterComponentLoaded.call(app.config.appKey, props.pageKey, 'Panel', props.panelKey, props);
        return function () {
            app.hooks.afterComponentUnloaded.call(app.config.appKey, props.pageKey, 'Panel', props.panelKey, props);
        };
    }, []);
    if (props.meta.filter) {
        var filter = getFilter(props.pageKey, props.meta.filter);
        if (filter !== filterRef.current) {
            props.meta.__fetched = false;
            filterRef.current = filter;
        }
    }
    var get = useGET();
    var post = usePOST();
    var Comp = app.ui ? app.ui.Panel : null;
    var hasChild = false;
    // const panelItems =JSON.parse(JSON.stringify(props.items))
    if (panelItems && panelItems.current.length > 0) {
        if (panelItems.current[0].type && panelItems.current[0].type.length > 0) {
            hasChild = true;
        }
        else {
            var req_1 = function (meta) { return __awaiter(_this, void 0, void 0, function () {
                var result, prm;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            result = null;
                            prm = meta.params;
                            if (!(!meta.method || meta.method.toUpperCase() === 'GET')) return [3 /*break*/, 2];
                            return [4 /*yield*/, get(meta.url, (prm && prm.get) ? __assign({}, filterRef.current, prm.get) : __assign({}, filterRef.current))];
                        case 1:
                            result = (_a.sent()) || [];
                            return [2 /*return*/, result];
                        case 2:
                            if (!(meta.method.toUpperCase() === 'POST')) return [3 /*break*/, 4];
                            return [4 /*yield*/, post(meta.url, (prm && prm.post) ? __assign({}, filterRef.current, prm.post) : {})];
                        case 3:
                            result = _a.sent();
                            return [2 /*return*/, result];
                        case 4: return [2 /*return*/];
                    }
                });
            }); };
            var handleItems_1 = function (panelData) {
                var newItems = app.hooks.getNewIPaneltems.call(app.config.appKey, props.pageKey, props.panelKey, panelItems.current, panelData);
                if (newItems && (typeof newItems !== 'string') && Array.isArray(newItems) && newItems.length > 0) {
                    panelItems.current = newItems;
                }
                panelItems.current.forEach(function (i) {
                    if (i.meta && i.meta.link) {
                        i.onClick = function () {
                            var link = i.meta.link;
                            if (link === '<') {
                                props.history.goBack();
                            }
                            else if (link.startsWith('/')) {
                                props.history.push(link.substring(1));
                            }
                            else {
                                props.history.push(props.match.url + "/" + link);
                            }
                        };
                    }
                    else if (i.meta && i.meta.url && i.meta.method) {
                        if (i.value && typeof i.value === 'string' && i.value.startsWith('$#') && !i.__fetched) {
                            i.__fetched = true;
                            req_1(i.meta).then(function (result) {
                                if (result && result.data) {
                                    i.value = getValueByKeypath(result.data, i.value.split('$#')[1]);
                                    props.forceUpdate();
                                }
                            });
                        }
                        else if (!i.__fetched) {
                            i.onClick = function () { return __awaiter(_this, void 0, void 0, function () {
                                var result;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, req_1(i.meta)];
                                        case 1:
                                            result = _a.sent();
                                            if (result)
                                                props.forceUpdate();
                                            return [2 /*return*/];
                                    }
                                });
                            }); };
                        }
                    }
                    if (i.value && typeof i.value === 'string' && i.value.startsWith('$.') && panelData) {
                        i.value = getValueByKeypath(panelData, i.value.split('$.')[1]);
                        props.forceUpdate();
                    }
                });
            };
            if (props.meta && props.meta.url && props.meta.method && !props.meta.__fetched) {
                props.meta.__fetched = true;
                app.hooks.beforePanelFetch.call(app.config.appKey, props.pageKey, props.panelKey, props);
                req_1(props.meta).then(function (result) {
                    if (result) {
                        handleItems_1(result.data);
                    }
                });
            }
            else {
                handleItems_1();
            }
        }
    }
    return (React.createElement(Comp, { items: hasChild ? [] : panelItems.current, title: props.meta.label, width: props.meta.width, columnsCount: props.meta.columnsCount, headerColor: props.meta.headerColor, headerBgColor: props.meta.headerBgColor }, hasChild ?
        React.createElement(Stack, { pageKey: props.pageKey, items: panelItems.current, direction: props.meta.direction ? props.meta.direction : 'vertical', stackKey: props.pageKey + "_" + props.panelKey + "_main_stack", history: props.history, match: props.match }) : null));
}
var Panel = _Panel;

function _PageIframe(props) {
    var offset = props.offset || 0;
    var _a = __read(React.useState((window.innerHeight - offset) + 'px'), 2), height = _a[0], setHeight = _a[1];
    React.useEffect(function () {
        var resizeListener = function (e) {
            setHeight((e.target.innerHeight - offset) + 'px');
        };
        window.addEventListener('resize', resizeListener);
        return function () {
            window.removeEventListener('resize', resizeListener);
        };
    });
    return (React.createElement("iframe", { style: {
            height: height,
            overflow: 'visible',
            margin: '-20px',
            marginTop: '-18px',
            width: '100%'
        }, src: props.url, frameBorder: "0" }));
}
var PageIframe = _PageIframe;

function _Iframe(props) {
    return (props.meta && props.meta.block ?
        React.createElement("iframe", { style: __assign({ width: '100%' }, props.style), src: props.meta.href, frameBorder: "0" })
        :
            React.createElement(PageIframe, { url: props.meta.href, offset: props.meta.offset ? parseInt(props.meta.offset) : 62 }));
}
var Iframe = _Iframe;

function _Stack(props) {
    var app = React.useContext(App);
    React.useEffect(function () {
        app.hooks.afterComponentLoaded.call(app.config.appKey, props.pageKey, 'Stack', props.stackKey, props);
        return function () {
            app.hooks.afterComponentUnloaded.call(app.config.appKey, props.pageKey, 'Stack', props.stackKey, props);
        };
    }, []);
    var vertical = props.direction === 'vertical';
    var _a = __read(React.useReducer(function (x) { return x + 1; }, 0), 2), ignored = _a[0], _forceUpdate = _a[1];
    function forceUpdate() {
        _forceUpdate(1);
    }
    return (React.createElement("div", { style: __assign({ display: 'flex', flexDirection: vertical ? 'column' : 'row' }, props.style) }, props.items.map(function (c) {
        var meta = c.meta || {};
        switch (c.type) {
            case 'Table':
                return (React.createElement(Table, { pageKey: props.pageKey, tableKey: c.key, style: __assign({}, (vertical ? { marginBottom: 20 } : { marginRight: 10 }), meta.style), key: c.key, columns: c.items, meta: meta, forceUpdate: forceUpdate, history: props.history, match: props.match }));
            case 'Form':
                return (React.createElement(Form, { pageKey: props.pageKey, formKey: c.key, style: __assign({}, (vertical ? { marginBottom: 20 } : { marginRight: 10 }), meta.style), key: c.key, items: c.items, meta: meta, forceUpdate: forceUpdate, history: props.history, match: props.match }));
            case 'Stack':
                return (React.createElement(Stack, { key: c.key, pageKey: props.pageKey, stackKey: c.key, items: c.items, direction: meta.direction, style: __assign({}, (vertical ? { marginBottom: 20 } : { marginRight: 10 }), meta.style), history: props.history, match: props.match }));
            case 'Button':
                return (React.createElement(Button, { key: c.key, pageKey: props.pageKey, buttonKey: c.key, meta: meta, style: __assign({}, (vertical ? { marginBottom: 20 } : { marginRight: 10 }), meta.style), forceUpdate: forceUpdate, history: props.history, match: props.match }));
            case 'Modal':
                return (React.createElement(Modal, { key: c.key, pageKey: props.pageKey, modalKey: c.key, contents: c.items, title: meta.label, width: meta.width, forceUpdate: forceUpdate, style: meta.style, history: props.history, match: props.match }));
            case 'Tabs':
                return (React.createElement(Tabs, { key: c.key, pageKey: props.pageKey, tabsKey: c.key, items: c.items, style: meta.style, history: props.history, match: props.match }));
            case 'Panel':
                return (React.createElement(Panel, { key: c.key, pageKey: props.pageKey, panelKey: c.key, items: c.items, style: meta.style, history: props.history, match: props.match, forceUpdate: forceUpdate, meta: meta }));
            case 'Checkbox':
                return (React.createElement(Checkbox, { key: c.key, pageKey: props.pageKey, checkboxKey: c.key, meta: meta, style: __assign({}, (vertical ? { marginBottom: 20 } : { marginRight: 10 }), meta.style), forceUpdate: forceUpdate }));
            case 'Iframe':
                return (React.createElement(Iframe, { key: c.key, pageKey: props.pageKey, iframeKey: c.key, style: meta.style, meta: meta }));
            default:
                return null;
        }
    })));
}
var Stack = React.memo(_Stack);

// let formItems: FormItem[] = []
function _Form(props) {
    var app = React.useContext(App);
    var items = React.useRef(JSON.parse(JSON.stringify(props.items)));
    React.useEffect(function () {
        app.hooks.afterComponentLoaded.call(app.config.appKey, props.pageKey, 'Form', props.formKey, props);
        return function () {
            items.current = [];
            app.hooks.afterComponentUnloaded.call(app.config.appKey, props.pageKey, 'Form', props.formKey, props);
        };
    }, []);
    var _a = Pages.useContainer(), getParams = _a.getParams, setFilter = _a.setFilter, setParams = _a.setParams, hideModal = _a.hideModal;
    items.current.forEach(function (i) {
        if (i.__done) {
            return;
        }
        if (i.value && (typeof i.value === 'string') && i.value.startsWith('$.') && props.meta.modal) {
            var params = getParams(props.pageKey, props.meta.modal);
            if (params) {
                var valueKey = i.value.split('.')[1];
                i.value = params[valueKey];
            }
        }
        if (i.meta && typeof i.meta.data === 'string' && i.meta.data.startsWith('$.')) {
            if (props.meta.modal) {
                var params = getParams(props.pageKey, props.meta.modal);
                if (params) {
                    var valueKey = i.meta.data.split('.')[1];
                    i.meta.data = params[valueKey] || [];
                }
                else {
                    i.meta.data = [];
                }
            }
        }
        i.__done = true;
        app.hooks.beforeFormItemFinalization.call(app.config.appKey, props.pageKey, props.formKey, props, i);
    });
    var newItems = useSelect(props.pageKey, props.formKey, items.current, 1);
    app.hooks.beforeFormAllItemsFinalization.call(app.config.appKey, props.pageKey, props.formKey, props, newItems);
    var submit = useSubmit(props.meta.url, props.meta.method, props.pageKey, props.meta.modal);
    var Comp = app.ui ? app.ui.Form : null;
    return (React.createElement(Comp, { style: __assign({}, props.style), inModal: props.meta.modal && props.meta.modal.length > 0, className: props.className, items: newItems, columnsCount: props.meta.columnsCount, rowColCounts: props.meta.rowColCounts, labelPosition: props.meta.labelPosition, disableGroupCol: props.meta.disableGroupCol, actionsShow: props.meta.actionsShow, submitTitle: props.meta.submitTitle, clearTitle: props.meta.clearTitle, actionDirection: props.meta.actionDirection, clearButtonShow: props.meta.clearButtonShow, accessories: props.meta.accessories ? React.createElement(Stack, { pageKey: props.pageKey, items: props.meta.accessories, direction: "vertical", stackKey: props.pageKey + "_" + props.formKey + "_accessories_stack", history: props.history, match: props.match }) : undefined, onSubmit: function (values) {
            var keys = newItems.filter(function (i) { return !i.actionDisabled; }).map(function (i) { return i.key; });
            var keyAliasMap = {};
            newItems.filter(function (i) { return i.alias; }).forEach(function (i) {
                keyAliasMap[i.key] = i.alias;
            });
            var newValues = {};
            Object.keys(values).forEach(function (k) {
                if (values[k] && keys.includes(k)) {
                    var vk = keyAliasMap[k] || k;
                    newValues[vk] = values[k];
                }
            });
            var extraValues = getParams(props.pageKey, props.formKey);
            newValues = __assign({}, newValues, extraValues);
            if (props.meta.params && props.meta.params.post) {
                var post_1 = props.meta.params.post;
                var keys_1 = Object.keys(post_1);
                if (keys_1 && keys_1.length > 0) {
                    keys_1.forEach(function (k) {
                        var value = post_1[k];
                        if (value && (value + '').startsWith('$.') && props.meta.modal) {
                            var modalParams = getParams(props.pageKey, props.meta.modal);
                            if (post_1) {
                                var valueKey = value.split('.')[1];
                                newValues[k] = modalParams[valueKey];
                            }
                        }
                        else {
                            newValues[k] = value;
                        }
                    });
                }
            }
            app.hooks.beforeFormSubmit.call(app.config.appKey, props.pageKey, props.formKey, newValues);
            if (props.meta.componentKey) {
                setParams(props.pageKey, props.meta.componentKey, newValues);
                if (props.meta.modal) {
                    hideModal(props.pageKey, props.meta.modal);
                }
            }
            else if (props.meta.filter) {
                setFilter(props.pageKey, props.meta.filter, newValues);
                if (props.meta.modal) {
                    hideModal(props.pageKey, props.meta.modal);
                }
            }
            else {
                submit(newValues);
            }
        } }));
}
var Form = React.memo(_Form);

function _Alert(props) {
    var app = React.useContext(App);
    React.useEffect(function () {
        app.hooks.afterComponentLoaded.call(app.config.appKey, 'global', 'Alert', props.type, props);
        return function () {
            app.hooks.afterComponentUnloaded.call(app.config.appKey, 'global', 'Alert', props.type, props);
        };
    }, []);
    var Comp = app.ui ? app.ui.Alert : null;
    return (React.createElement(Comp, { type: props.type, message: props.message, description: props.description, onClose: props.onClose }));
}
var Alert = React.memo(_Alert);

function _Loading(props) {
    var app = React.useContext(App);
    React.useEffect(function () {
        app.hooks.afterComponentLoaded.call(app.config.appKey, 'global', 'Loading', props.type, props);
        return function () {
            app.hooks.afterComponentUnloaded.call(app.config.appKey, 'global', 'Loading', props.type, props);
        };
    }, []);
    var Comp = app.ui ? app.ui.Loading : null;
    return (React.createElement(Comp, { show: props.show, type: props.type, timeout: props.timeout }));
}
var Loading = React.memo(_Loading);

function _Indicator() {
    var _a = Pages.useContainer(), error = _a.error, warning = _a.warning, success = _a.success, info = _a.info, requestQuantity = _a.requestQuantity, clearError = _a.clearError, clearInfo = _a.clearInfo, clearSuccess = _a.clearSuccess, clearWarning = _a.clearWarning, clearRequest = _a.clearRequest;
    var errorAlert = error && (React.createElement(Alert, { type: "error", message: error.code ? '操作失败' : '发生错误', description: error.message || JSON.stringify(error), onClose: clearError }));
    var warningAlert = warning && (React.createElement(Alert, { type: "warning", message: warning.title, description: warning.message, onClose: clearWarning }));
    var infoAlert = info && (React.createElement(Alert, { type: "info", message: info.title, description: info.message, onClose: clearInfo }));
    var successAlert = success && (React.createElement(Alert, { type: "success", message: success.title, description: success.message, onClose: clearSuccess }));
    return (React.createElement(React.Fragment, null,
        errorAlert,
        warningAlert,
        infoAlert,
        successAlert,
        React.createElement(Loading, { show: requestQuantity > 0, type: "overall", timeout: clearRequest })));
}
var Indicator = React.memo(_Indicator);

function inIframe() {
    try {
        return window.self !== window.top;
    }
    catch (e) {
        return true;
    }
}

function _Index() {
    var hide = inIframe();
    var app = React.useContext(App);
    return (React.createElement(Layout, { config: app.config, hide: hide, renderSiderTopSection: function () {
            var section = app.hooks.renderSiderTopSection.call(app.config.appKey);
            if (!section || (typeof section === 'string')) {
                return null;
            }
            else {
                return section;
            }
        }, renderHeaderActions: function () {
            var actions = app.hooks.renderHeaderActions.call(app.config.appKey);
            if (!actions || (typeof actions === 'string')) {
                return null;
            }
            else {
                return actions;
            }
        }, renderRoutes: function (RouteComponents, mainRender) {
            return app.hooks.renderCustomRoutes.call(app.config.appKey, RouteComponents, mainRender);
        } }));
}
var Index = React.memo(_Index);

function PageContainer(props) {
    // console.log('>>>>PAGE>>>>', props)
    var app = React.useContext(App);
    React.useEffect(function () {
        app.hooks.afterPageLoaded.call(app.config.appKey, pageKey, props);
        return function () {
            app.hooks.afterPageUnloaded.call(app.config.appKey, pageKey, props);
        };
    }, []);
    var get = useGET();
    var type = "PAGE_JSON_FETCHED";
    var _a = __read(React.useReducer(function (state, action) {
        switch (action.type) {
            case type:
                return __assign({}, state, { data: action.data });
            default:
                throw new Error();
        }
    }, { data: props.pageJSON || [] }), 2), state = _a[0], dispatch = _a[1];
    React.useEffect(function () {
        function fetchPageJson(url) {
            return __awaiter(this, void 0, void 0, function () {
                var result;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, get(url)];
                        case 1:
                            result = _a.sent();
                            if (result && result.data && Array.isArray(result.data.pageJSON)) {
                                dispatch({ type: type, data: result.data.pageJSON });
                            }
                            else {
                                dispatch({ type: type, data: [] });
                            }
                            return [2 /*return*/];
                    }
                });
            });
        }
        if ((!props.pageJSON || !Array.isArray(props.pageJSON)) && props.pageAPI) {
            fetchPageJson(addParam(props.pageAPI, 'pageKey', props.pageKey));
        }
    }, []);
    var pageKey = props.pageKey;
    return React.useMemo(function () { return (React.createElement(Page, { pageKey: pageKey, style: { padding: 20, background: 'white' } },
        React.createElement(Stack, { pageKey: pageKey, items: state.data, direction: "vertical", stackKey: pageKey + "_main_stack", history: props.history, match: props.match }),
        React.createElement(Indicator, null))); }, [pageKey, state]);
}
var Page$1 = PageContainer;

function _Entry(props) {
    return (React.createElement(Pages.Provider, null,
        React.createElement(Page$1, { pageKey: props.pageKey, pageAPI: props.pageAPI, pageJSON: props.pageJSON, history: props.history, match: props.match })));
}
var Entry = React.memo(_Entry);

var Kitten = /** @class */ (function () {
    function Kitten(ui, config, plugins, debugHooks) {
        this.ui = ui;
        this.config = config;
        this.plugins = plugins;
        this.debugHooks = debugHooks;
    }
    Kitten.prototype.render = function (renderer, dom) {
        renderer.render(React.createElement(AppProvider, { ui: this.ui, config: this.config, plugins: this.plugins, debugHooks: this.debugHooks },
            React.createElement(Index, null)), dom, function () {
        });
    };
    return Kitten;
}());

exports.AppProvider = AppProvider;
exports.Entry = Entry;
exports.Kitten = Kitten;
exports.isMenuGroup = isMenuGroup;
//# sourceMappingURL=index.js.map
